﻿Imports Infragistics.Win

Class MyDrawFilter
    Implements IUIElementDrawFilter


    Public Function DrawElement(drawPhase As DrawPhase, ByRef drawParams As UIElementDrawParams) As Boolean Implements IUIElementDrawFilter.DrawElement
        If TypeOf drawParams.Element Is TextUIElement AndAlso TypeOf drawParams.Element.Parent Is EditorWithTextUIElement Then
            Dim brush As New SolidBrush(Color.Black)
            Dim text = TryCast(drawParams.Element, TextUIElement)

            Dim subject As String = text.Text
            Dim editSubject As String = subject.Replace(Environment.NewLine, " "c)

            Dim sf As New StringFormat()
            sf.FormatFlags = StringFormatFlags.NoWrap

            drawParams.Graphics.DrawString(editSubject, drawParams.Font, brush, drawParams.Element.Parent.Parent.Rect, sf)

            brush.Dispose()
        End If
        Return True
    End Function

    Public Function GetPhasesToFilter(ByRef drawParams As UIElementDrawParams) As DrawPhase Implements IUIElementDrawFilter.GetPhasesToFilter
        If TypeOf drawParams.Element Is TextUIElement Then
            Return DrawPhase.BeforeDrawElement
        Else
            Return DrawPhase.None
        End If
    End Function
End Class
